//
//  YHUatHelperViewModel.swift
//  galaxy
//
//  Created by david on 2024/7/23.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import Foundation
import HandyJSON


class YHUatModel : HandyJSON {
    var module_number : String = ""
    var result : Int = 0 //命中结果 0-未找到该规则，走默认逻辑 1-未命中，2-命中
    
    required init() {
    }
}

class YHUatListModel : HandyJSON {
    var list : [YHUatModel] = []
    
    required init() {
    }
}

class YHUatHelperViewModel : YHBaseViewModel {
    var dataList : YHUatListModel?
}

// MARK: - 共有方法
extension YHUatHelperViewModel {
    //请求灰度功能列表配置
    func getUatList(_ id: Int, callBackBlock:@escaping (_ success: Bool, _ error:YHErrorModel?)->()) {
        let params: [String : Any] = ["id": id]
        let strUrl = YHBaseUrlManager.shared.curURL() + YHAllApiName.Uat.uatListApi
        let _ = YHNetRequest.getRequest(url: strUrl, params: params) { [weak self] json, code in
            //1. json字符串 转 对象
            guard let self = self else { return }
            let dic = json.data
            guard let resultModel = YHUatListModel.deserialize(from: dic as? Dictionary) else {
                callBackBlock(false,nil)
                return
            }
            self.dataList = resultModel
            
            callBackBlock(true,nil)
        } failBlock: { err in
            callBackBlock(false,err)
        }
    }
}


// MARK: - 私有方法
private extension YHUatHelperViewModel {
    
}
